Subject: [decade] Related problem statement

From: Wesley Leggette <[email-masked]>
Date: Wed, 20 Jan 2010 12:55:40 -0600

Hello,

My company has a distributed storage system product which uses Erasure Codes
to store data reliably. We are hoping to standardize our protocols and data
formats. I recently sent out a question tot he apps discuss list asking if
anybody was working on something similar, and DECADE was pointed out to me.

Our problem and requirements are slightly different than those pointed out
in your problem statement. Specifically, we are more of a "hosted P2P"
environment. In effect, this means that some of the dynamic content lookup
is a bit simpler in the initial implementation of our system (because the
data is stored on fixed nodes run by one or more hosting providers). We also
originally envisioned (and have currently implemented) an application layer
protocol for data transport, though the possibility of a "transport
agnostic" protocol which could be encapsulated in P2P application protocols
is intriguing.

I think that there could be a lot of overlap between the requirements we are
facing and the requirements which will have to be addressed by DECADE.

I will be shortly submitting a problem statement of our own. Once I do, I
would like to invite you to read it and let me know if there would be any
interest in converging our two problems.

In the mean time, what is the status of this body? I see from the schedule
that you have an initial charter proposal. Has there been much progress
since then?

Wesley Leggette

---

From: Song Haibin <[email-masked]>
Date: Thu, 21 Jan 2010 15:26:07 +0800

Hi Wesley,

After reading some materials from your company's websit. From
http://www.cleversafe.com/vision/object-storage
http://www.cleversafe.com/vision/Replication_vs._Information_Dispersal
http://www.cleversafe.org/dispersed-storage/idas
http://www.cleversafe.com/vision/Dispersed_Data_Archiving_Top-10-Features

I think the product of your company is using Erasure Codes to store contents
and using p2p technologies to organize contents and in-network storage
devices. So I believe it is trying to solve some different problems than
DECADE's. Because we don't want to design a whole system but only a
signaling protocol between p2p application and in-network storage for
resource control and indication of underlying data access/transport
protocols. I'm happy to read your problem statement draft after you finish
it. But I don't know if there is opportunity to converge these two different
problem statements.

As for the status, we held a bar BOF at IETF 75, and a BOF at IETF 76. We
are trying to clarifing the scope and looking forward to form an working
group.

Thank you,
Haibin

> -----Original Message-----
> From: [email-masked] 
> [mailto:[email-masked]] On Behalf Of Wesley Leggette
> Sent: Thursday, January 21, 2010 2:56 AM
> To: [email-masked]
> Subject: [decade] Related problem statement
> 
> Hello,
> 
> My company has a distributed storage system product which 
> uses Erasure Codes to store data reliably. We are hoping to 
> standardize our protocols and data formats. I recently sent 
> out a question tot he apps discuss list asking if anybody was 
> working on something similar, and DECADE was pointed out to me.
> 
> Our problem and requirements are slightly different than 
> those pointed out in your problem statement. Specifically, we 
> are more of a "hosted P2P"
> environment. In effect, this means that some of the dynamic 
> content lookup is a bit simpler in the initial implementation 
> of our system (because the data is stored on fixed nodes run 
> by one or more hosting providers). We also originally 
> envisioned (and have currently implemented) an application 
> layer protocol for data transport, though the possibility of 
> a "transport agnostic" protocol which could be encapsulated 
> in P2P application protocols is intriguing.
> 
> I think that there could be a lot of overlap between the 
> requirements we are facing and the requirements which will 
> have to be addressed by DECADE.
> 
> I will be shortly submitting a problem statement of our own. 
> Once I do, I would like to invite you to read it and let me 
> know if there would be any interest in converging our two problems.
> 
> 
> In the mean time, what is the status of this body? I see from 
> the schedule that you have an initial charter proposal. Has 
> there been much progress since then?
> 
> Wesley Leggette 
> 
> _______________________________________________
> decade mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/decade
>

---

From: Wesley Leggette <[email-masked]>
Date: Thu, 21 Jan 2010 10:21:57 -0600

Haibin,

I look forward to your response to our problem statement, which I hope to
finish up this week.

I should note that at this point, we are interested mainly in a signaling
protocol as well, though the fact that it has to work over various transport
layer streams may make the requirements too different.

With our system, we found that the difficultly is not in the use of Erasure
Codes (that part is well known), but in the constraints imposed by a
distributed system when you need to write large objects with many related
parts. This is where a good transaction and revision model have been
important. 

I will go into more detail in the problem statement, but I just want to note
that we feel that these constraints exist regardless of whether erasure
codes, wholesale replication, or data splitting (which as you have
previously noted is typical of most P2P applications) is used.

The problem has not been addressed as of yet because most P2P systems are
"single-seed/read-only", where an object is only transmitted by request from
the receiver regardless of it origin, and is only advertised when the object
is completely available from at least that seed origin. In a system where
objects are originated by a transmitter they may be advertised before they
are completely written. We feel that it is important ensure that some
guarantees can be made with regards to multi-part object completeness.

Even if we cannot converge our two problems, you may want to take some of
this into account in the DECADE design.

Wesley

---

From: Song Haibin <[email-masked]>
Date: Fri, 22 Jan 2010 14:13:12 +0800

>In a system where 
> objects are originated by a transmitter they may be 
> advertised before they are completely written. We feel that 
> it is important ensure that some guarantees can be made with 
> regards to multi-part object completeness.
> 

I'm not sure if you mean the in-network storage can advertise an object and
at the same time download multiple parts of this object from multiple peers
dynamically, or redirect the peers to get other parts from other addresses?
Usually we want the problem to be narrow scoped and I guess we don't want to
broaden DECADE's scope to that way.

Haibin

> From: Wesley Leggette [mailto:[email-masked]] 
> Sent: Friday, January 22, 2010 12:22 AM
> To: Song Haibin; DECADE
> Subject: Re: [decade] Related problem statement
> 
> 
> Haibin,
> 
> I look forward to your response to our problem statement, 
> which I hope to finish up this week.
> 
> I should note that at this point, we are interested mainly in 
> a signaling protocol as well, though the fact that it has to 
> work over various transport layer streams may make the 
> requirements too different.
> 
> With our system, we found that the difficultly is not in the 
> use of Erasure Codes (that part is well known), but in the 
> constraints imposed by a distributed system when you need to 
> write large objects with many related parts. This is where a 
> good transaction and revision model have been important. 
> 
> I will go into more detail in the problem statement, but I 
> just want to note that we feel that these constraints exist 
> regardless of whether erasure codes, wholesale replication, 
> or data splitting (which as you have previously noted is 
> typical of most P2P applications) is used.
> 
> The problem has not been addressed as of yet because most P2P 
> systems are "single-seed/read-only", where an object is only 
> transmitted by request from the receiver regardless of it 
> origin, and is only advertised when the object is completely 
> available from at least that seed origin. In a system where 
> objects are originated by a transmitter they may be 
> advertised before they are completely written. We feel that 
> it is important ensure that some guarantees can be made with 
> regards to multi-part object completeness.
> 
> Even if we cannot converge our two problems, you may want to 
> take some of this into account in the DECADE design.
> 
> Wesley
> 
> 
> 
> > I think the product of your company is using Erasure Codes to store 
> > contents and using p2p technologies to organize contents and 
> > in-network storage devices. So I believe it is trying to solve some 
> > different problems than DECADE's. Because we don't want to design a 
> > whole system but only a signaling protocol between p2p 
> application and 
> > in-network storage for resource control and indication of 
> underlying 
> > data access/transport protocols. I'm happy to read your problem 
> > statement draft after you finish it. But I don't know if there is 
> > opportunity to converge these two different problem statements.
> > 
> > As for the status, we held a bar BOF at IETF 75, and a BOF 
> at IETF 76. 
> > We are trying to clarifing the scope and looking forward to form an 
> > working group.
> > 
> > Thank you,
> > Haibin
> > 
> > 
> > 
> > 
> >> My company has a distributed storage system product which uses 
> >> Erasure Codes to store data reliably. We are hoping to standardize 
> >> our protocols and data formats. I recently sent out a 
> question tot he 
> >> apps discuss list asking if anybody was working on 
> something similar, 
> >> and DECADE was pointed out to me.
> >> 
> >> Our problem and requirements are slightly different than those 
> >> pointed out in your problem statement. Specifically, we 
> are more of a 
> >> "hosted P2P"
> >> environment. In effect, this means that some of the 
> dynamic content 
> >> lookup is a bit simpler in the initial implementation of 
> our system 
> >> (because the data is stored on fixed nodes run by one or 
> more hosting 
> >> providers). We also originally envisioned (and have currently 
> >> implemented) an application layer protocol for data 
> transport, though 
> >> the possibility of a "transport agnostic" protocol which could be 
> >> encapsulated in P2P application protocols is intriguing.
> >> 
> requirements 
> >> we are facing and the requirements which will have to be 
> addressed by 
> >> DECADE.
> >> 
> >> Once I do, I would like to invite you to read it and let 
> me know if 
> >> there would be any interest in converging our two problems.
> >> 
> >> 
> >> In the mean time, what is the status of this body? I see from the 
> >> schedule that you have an initial charter proposal. Has there been 
> >> much progress since then?
> >> 
> >> Wesley Leggette
> >>